local _, L = ...
local mediaFolder = "Interface\\AddOns\\".._.."\\Media\\"

local C_Timer_After = C_Timer.After

textPanelMixin = {}


function textPanelMixin:ShowText(str, timeShow)
	if str then
		if textPanel.AnimOut:IsPlaying() then
			textPanel.AnimOut:Stop()
		end
		if textPanel.AnimIn:IsPlaying() then
			textPanel.AnimIn:Stop()
		end
		textPanelText:SetText(str)
		textPanel:SetSize(textPanelText:GetStringWidth() + 10, textPanelText:GetStringHeight() + 2)
		textPanel:Show()
		textPanel.AnimIn:Play()
		
		if timeShow then
			C_Timer_After(timeShow, function()
				textPanelText:SetText(nil)
				textPanel.AnimOut:Play()
			--	textPanel.AnimOut:SetScript("OnFinished", function(self)
			--		textPanel:Hide()
			--	end)
			end)
		end
	end
end

function textPanelMixin:OnEvent(event, ...)
	if ( event == "ADDON_LOADED" ) then
		local name = ...
		if name == _ then
			L.config.mythic_text_panel_unlock = false
			
			textPanel:SetSize(100, 50)
			textPanel:SetPoint("TOP", UIParent, "TOP" , 0, -60)
			textPanel:SetMovable(true)
			textPanel:SetClampedToScreen(true)
			textPanel:SetScript("OnDragStart", function(self) self:StartMoving() end)
			textPanel:SetScript("OnDragStop", function(self) self:StopMovingOrSizing() end)
			textPanel:RegisterForDrag("LeftButton")
			textPanel:SetMouseClickEnabled(true)
			textPanel:SetScript("OnMouseDown", function(self, button)
				if button == "RightButton" then --and not InCombatLockdown() then
					L.config.mythic_text_panel_unlock = false
					LibStub("AceConfigRegistry-3.0"):NotifyChange("Nameplates")
					self:EnableMouse(false)
					self:Hide()
				end
			end)
			textPanel.border = CreateFrame("Frame", nil, textPanel, "BackdropTemplate")
			textPanel.border:SetFrameLevel(textPanel:GetFrameLevel())
			textPanel.border:ClearAllPoints()
			textPanel.border:SetPoint("TOPLEFT", textPanel, "TOPLEFT", -12, 12)
			textPanel.border:SetPoint("BOTTOMRIGHT", textPanel, "BOTTOMRIGHT", 12, -12)
			textPanel.border:SetBackdrop({bgFile = mediaFolder..'Backdrop_Talkbox.blp', edgeFile = mediaFolder..'Edge_Talkbox_BG.blp', edgeSize = 12, insets = { left = 12, right = 12, top = 12, bottom = 12 }})
			textPanel.border:Show()
	
			textPanel:EnableMouse(false)
		
			local tPanelText = textPanel:CreateFontString("textPanelText", nil, nil)
			tPanelText:SetPoint("CENTER")
			tPanelText:SetFont(STANDARD_TEXT_FONT, 16, "OUTLINE")
			tPanelText:SetTextColor(0, 1, .5)
			tPanelText:SetJustifyH("CENTER")
			tPanelText:SetText(nil)
	
			textPanel:Hide()
			
			if IsAddOnLoaded(_) then
				self:UnregisterEvent('ADDON_LOADED')
				self.ADDON_LOADED = nil
			end
		end
	end
end

function textPanelMixin:OnLoad()
	for _, event in pairs({
		"ADDON_LOADED",
	}) do self:RegisterEvent(event) end
end
